<?php

namespace Drupal\library_manager\Tests;

/**
 * Tests CodeMirror library assets.
 *
 * @group library_manager
 */
class CodeMirrorAssetsTest extends TestBase {

  /**
   * Tests that CodeMirror assets are loaded properly.
   */
  public function testAssets() {

    // Check CDN mode.
    $this->drupalGet('admin/structure/library/definition/alpha/js/add');
    $js_xpath = '//script[@src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.17.0/%s"]';
    $this->assertByXpath(sprintf($js_xpath, 'codemirror.js'));
    $this->assertByXpath(sprintf($js_xpath, 'mode/javascript/javascript.js'));
    $this->assertByXpath(sprintf($js_xpath, 'mode/css/css.js'));
    $this->assertByXpath(sprintf($js_xpath, 'mode/yaml/yaml.js'));
    $this->assertByXpath(sprintf($js_xpath, 'addon/fold/foldcode.js'));
    $this->assertByXpath(sprintf($js_xpath, 'addon/display/fullscreen.js'));
    $css_xpath = '//head/link[@rel="stylesheet" and @href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.17.0/%s"]';
    $this->assertByXpath(sprintf($css_xpath, 'codemirror.css'));
    $this->assertByXpath(sprintf($css_xpath, 'addon/display/fullscreen.css'));

    // Check local mode.
    $this->drupalPostForm('admin/structure/library/settings', ['codemirror[cdn]' => FALSE], 'Save configuration');
    $this->drupalGet('admin/structure/library/definition/alpha/js/add');

    $js_xpath = '//script[contains(@src, "/libraries/codemirror/%s")]';
    $this->assertByXpath(sprintf($js_xpath, 'lib/codemirror.js'));
    $this->assertByXpath(sprintf($js_xpath, 'mode/javascript/javascript.js'));
    $this->assertByXpath(sprintf($js_xpath, 'mode/css/css.js'));
    $this->assertByXpath(sprintf($js_xpath, 'mode/yaml/yaml.js'));
    $this->assertByXpath(sprintf($js_xpath, 'addon/fold/foldcode.js'));
    $this->assertByXpath(sprintf($js_xpath, 'addon/display/fullscreen.js'));
    $css_xpath = '//head/style[contains(., "/libraries/codemirror/%s")]';
    $this->assertByXpath(sprintf($css_xpath, 'lib/codemirror.css'));
    $this->assertByXpath(sprintf($css_xpath, 'addon/display/fullscreen.css'));
  }

}
