<?php

namespace Drupal\library_manager\Tests;

/**
 * Tests library overriding.
 *
 * @group library_manager
 */
class LibraryOverrideTest extends TestBase {

  /**
   * Tests that a library can be overriden.
   */
  public function testOverriding() {
    // jQuery is loaded because alpha library depends upon it.
    $this->drupalGet('<front>');
    $this->assertRaw('/core/assets/vendor/jquery/jquery.min.js');
    $this->assertNoRaw('/sites/default/files/libraries/custom/jquery_overridden/assets/vendor/jquery/jquery.min.js');

    // Override core/jquery library.
    $this->drupalGet('admin/structure/library');
    $this->clickLinkInRow('core/jquery', 'Create definition');
    $this->drupalPostForm(NULL, ['id' => 'jquery_overridden'], 'Create');

    // Make sure that the jQuery library is replaced.
    $this->drupalGet('<front>');
    $this->assertNoRaw('/core/assets/vendor/jquery/jquery.min.js');
    $this->assertRaw('/sites/default/files/libraries/custom/jquery_overridden/assets/vendor/jquery/jquery.min.js');
  }

}
